#Covered by GPL V2.0
# Coded By deepbit (Carlos del Ojo Elias) based on simple, extensible Python SMTP Server (smtps.py,v 1.10 2003/12/01 22:12:23 lsmithso)
# email deepbit@gmail.com


import sys, socket, string,TextParser,reqresp,smtplib,gzip,StringIO,base64,os

MXrecords={}

def getSERVER(email):
	email_server=email.split("@")[1]
	if email_server in MXrecords:
		return MXrecords[email_server]
	else:
		a=os.popen("host -t mx %s" % (email_server))
		a=a.readlines()
		tmp=a[0].split(" ")[-1].strip()
		if tmp=="present":
			MXrecords[email_server]=email_server
		else:
			MXrecords[email_server]=tmp
		return MXrecords[email_server]
	



class SMTPServerInterface:

	def helo(self, args):
		return None
	
	def mailFrom(self, args):
		return None
		
	def rcptTo(self, args):
		return None

	def data(self, args):
		return None

	def quit(self, args):
		return None

	def reset(self, args):
		return None
	
#
# Some helper functions for manipulating from & to addresses etc.
#

def stripAddress(address):
	start = string.index(address, '<') + 1
	end = string.index(address, '>')
	return address[start:end]

def splitTo(address):
	start = string.index(address, '<') + 1
	sep = string.index(address, '@') + 1
	end = string.index(address, '>')
	return (address[sep:end], address[start:end],)

def insertSpaces (string):
	''' insert a space every 2 characters'''
	fstring=""
	count=0
	for i in string:
		if count==2:
			count=0
			fstring+=" "
		count+=1
		fstring+=(i)
	return fstring
		


class SMTPServerInterfaceHTTPSMTP_Tunnel(SMTPServerInterface):
	def __init__(self):
		self.orig=""
		self.me=""
		self.req=""

	def helo(self, args):
		pass
	
	def mailFrom(self, args):
		self.orig=stripAddress(args)
		
	def rcptTo(self, args):
		self.me=stripAddress(args)

	def data(self, args):
		tp=TextParser.TextParser()
		tp.setSource("string",args)
		if not tp.readUntil("^([sS]ubject:)(.*)$"):
			return
		self.subject=tp[1].strip()
		if not tp.readUntil("^(prot##)(.*)$"):
			return
		protocol=tp[1]

		rawRequest=""
		while tp.readLine():
			rawRequest+=tp.lastFull_line

		req=reqresp.Request()
		req.parseRequest(rawRequest)
		url=protocol+"://"+req["Host"]+req.path
		req.setUrl(url)
		req.perform()
		self.response=req.response.getAll()

		zbuf = StringIO.StringIO()
		zfile = gzip.GzipFile(mode = 'wb',  fileobj = zbuf, compresslevel = 9)
		zfile.write(self.response)
		zfile.close()

		server = smtplib.SMTP(getSERVER(self.orig))
		
		b64response=insertSpaces(base64.b64encode(zbuf.getvalue()))

		server.sendmail(self.me, self.orig,"MIME-Version: 1.0\r\nContent-Type: text/plain; charset=iso-8859-1\r\n"+"From: "+self.me+"\r\n"+"To: "+self.orig+"\r\n"+ "Subject: "+self.subject+"-"+str(len(b64response))+"\r\n\r\n"+ b64response)
		print "mail sent",self.subject,getSERVER(self.orig)


		server.quit()



	def quit(self, args):
		pass

	def reset(self, args):
		pass
	

#
# This drives the state for a single RFC821 message.
#
class SMTPServerEngine:
	"""
	Server engine that calls methods on the SMTPServerInterface object
	passed at construction time. It is constructed with a bound socket
	connection to a client. The 'chug' method drives the state,
	returning when the client RFC821 transaction is complete. 
	"""

	ST_INIT = 0
	ST_HELO = 1
	ST_MAIL = 2
	ST_RCPT = 3
	ST_DATA = 4
	ST_QUIT = 5
	
	def __init__(self, socket, impl):
		self.impl = impl;
		self.socket = socket;
		self.state = SMTPServerEngine.ST_INIT
		
	def chug(self):
		"""
		Chug the engine, till QUIT is received from the client. As
		each RFC821 message is received, calls are made on the
		SMTPServerInterface methods on the object passed at
		construction time.
		"""
		
		self.socket.send("220 Wellcome to HoStunnel by deepbit (based in smtps.py-lsmithso)\r\n")
		while 1:
			data = ''
			completeLine = 0
			# Make sure an entire line is received before handing off
			# to the state engine. Thanks to John Hall for pointing
			# this out.
			while not completeLine:
				lump = self.socket.recv(1024);
				if len(lump):
					data += lump
					if (len(data) >= 2) and data[-2:] == '\r\n':
						completeLine = 1
						if self.state != SMTPServerEngine.ST_DATA:
							rsp, keep = self.doCommand(data)
						else:
							rsp = self.doData(data)
							if rsp == None:
								continue
						self.socket.send(rsp + "\r\n")
						if keep == 0:
							self.socket.close()
							return
				else:
					# EOF
					return
		return
			
	def doCommand(self, data):
		"""Process a single SMTP Command"""
		cmd = data[0:4]
		cmd = string.upper(cmd)
		keep = 1
		rv = None
		if cmd == "HELO":
			self.state = SMTPServerEngine.ST_HELO
			rv = self.impl.helo(data)
		elif cmd == "RSET":
			rv = self.impl.reset(data)
			self.dataAccum = ""
			self.state = SMTPServerEngine.ST_INIT
		elif cmd == "NOOP":
			pass
		elif cmd == "QUIT":
			rv = self.impl.quit(data)
			keep = 0
		elif cmd == "MAIL":
			if self.state != SMTPServerEngine.ST_HELO:
				return ("503 Bad command sequence", 1)
			self.state = SMTPServerEngine.ST_MAIL
			rv = self.impl.mailFrom(data)
		elif cmd == "RCPT":
			if (self.state != SMTPServerEngine.ST_MAIL) and (self.state != SMTPServerEngine.ST_RCPT):
				return ("503 Bad command sequence", 1)
			self.state = SMTPServerEngine.ST_RCPT
			rv = self.impl.rcptTo(data)
		elif cmd == "DATA":
			if self.state != SMTPServerEngine.ST_RCPT:
				return ("503 Bad command sequence", 1)
			self.state = SMTPServerEngine.ST_DATA
			self.dataAccum = ""
			return ("354 OK, Enter data, terminated with a \\r\\n.\\r\\n", 1)
		else:
			return ("505 Eh? WTF was that?", 1)

		if rv:
			return (rv, keep)
		else:
			return("250 OK", keep)

	def doData(self, data):
		"""
		Process SMTP Data. Accumulates client DATA until the
		terminator is found.
		"""
		self.dataAccum = self.dataAccum + data
		if len(self.dataAccum) > 4 and self.dataAccum[-5:] == '\r\n.\r\n':
			self.dataAccum = self.dataAccum[:-5]
			rv = self.impl.data(self.dataAccum)
			self.state = SMTPServerEngine.ST_HELO
			if rv:
				return rv
			else:
				return "250 OK - Data and terminator. found"
		else:
			return None
	
class SMTPServer:
	"""
	A single threaded SMTP Server connection manager. Listens for
	incoming SMTP connections on a given port. For each connection,
	the SMTPServerEngine is chugged, passing the given instance of
	SMTPServerInterface. 
	"""
	
	def __init__(self, port):
		try:
			self._socket = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
			self._socket.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, 1)
			self._socket.bind(("", port))
			self._socket.listen(5)
		except:
			print "Error starting SMTP server. Remember you must run the server with root privileges."
			sys.exit(-1)
	  
	def serve(self, impl = None):
		while 1:
			nsd = self._socket.accept()
			if impl == None:
				impl = SMTPServerInterfaceHTTPSMTP_Tunnel()
			engine = SMTPServerEngine(nsd[0], impl)
			try:
				engine.chug()
			except:
				pass
			


if __name__ == '__main__':

	banner='''
*******************************************
* Http-SMTP Proxy by Carlos del ojo Elias *
* External Server                 *********
* email: cdelojo@edge-security.com*
* website: www.edge-security.com  *
***********************************
'''
	print banner

	port = 25
	try:
		s = SMTPServer(port)
		print "Listening in port 25..."
		s.serve()
	except:
		print "Bye!..."
		print 
