#!/usr/local/bin/python
#Covered by GPL V2.0
# Coded By deepbit (Carlos del Ojo Elias)
# email deepbit@gmail.com


from OpenSSL import SSL
import threading
import re
import mailretriever
import time
import smtplib,getpass
import ConfigParser
import sys


mutex=1
Semaphore_Mutex=threading.BoundedSemaphore(value=mutex)
GLOBALID=1


import BaseHTTPServer, select, socket, SocketServer, urlparse


class ProxyHandler (BaseHTTPServer.BaseHTTPRequestHandler):
	__base = BaseHTTPServer.BaseHTTPRequestHandler
	__base_handle = __base.handle

	server_version = "Vapwn PROXY"
	rbufsize = 0						# self.rfile Be unbuffered

	def _connect_to(self, netloc, soc):
		i = netloc.find(':')
		if i >= 0:
			host_port = netloc[:i], int(netloc[i+1:])
		else:
			host_port = netloc, 80
		try: soc.connect(host_port)
		except socket.error, arg:
			try: 
				msg = arg[1]
			except: 
				msg = arg
			self.send_error(404, msg)
			return 0
		return 1



	def do_CONNECT(self):
		global GLOBALID
		global localemail
		global remoteemail
		global smtp_host

		soc = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
		try:
			self.wfile.write(self.protocol_version + " 200 Connection established\r\n")
			self.wfile.write("Proxy-agent: %s\r\n" % self.version_string())
			self.wfile.write("\r\n")

			ctx = SSL.Context(SSL.SSLv23_METHOD)
			ctx.set_timeout(5)
  			fpem = 'server.pem'
   			ctx.use_privatekey_file (fpem)
			ctx.set_verify(SSL.VERIFY_NONE,self.test)
			ctx.use_certificate_file(fpem)
			sok=SSL.Connection(ctx,self.connection)
			sok.set_accept_state()
			
			ssldat=self._read(sok,300)
			
			Semaphore_Mutex.acquire()
			reqid=GLOBALID
			GLOBALID+=1
			Semaphore_Mutex.release()
			
			server = smtplib.SMTP(smtp_host)
			server.sendmail(localemail, remoteemail, "Subject: WM_req-"+str(reqid)+"\r\nprot##https\r\n"+ssldat+"\r\n.\r\n")
			server.quit()

			while True:
				if reqid in mr.responses:
					result=mr.responses[reqid]
					break
				time.sleep(0.5)

			sok.sendall(result)
			sok.close()


				
		finally:
			soc.close()
			self.connection.close()

	def test():
		return ok

	def do_GET(self):
		(scm, netloc, path, params, query, fragment) = urlparse.urlparse( self.path, 'http')
		if scm != 'http' or fragment or not netloc:
			self.send_error(400, "bad url %s" % self.path)
			return
		soc = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
		try:
			if self._connect_to(netloc, soc):
				rawrequest="%s %s %s\r\n" % ( self.command, urlparse.urlunparse(('', '', path, params, query, '')), self.request_version)
				
				self.headers['Connection'] = 'close'
				del self.headers['Proxy-Connection']
				for key_val in self.headers.items():
					rawrequest+="%s: %s\r\n" % key_val
				rawrequest+="\r\n"
				soc.send(rawrequest)
				self._read_write(soc,520,rawrequest)
		finally:
			soc.close()
			self.connection.close()

	def _read(self, soc, max_idling=520):
		iw = [soc]
		ow = []
		count = 0
		rawrequest=""
		while 1:
			count += 1
			(ins, _, exs) = select.select(iw, ow, iw, 0.5)
			if exs: break
			if ins:
				rawrequest+= soc.recv(8192)
			else:
				break
			if count == max_idling:
				break

		return rawrequest
	

	def _read_write(self, soc, max_idling=520,rawrequest=""):
		global GLOBALID
		global localemail
		global remoteemail
		global smtp_host

		Semaphore_Mutex.acquire()
		reqid=GLOBALID
		GLOBALID+=1
		Semaphore_Mutex.release()

		try:
			server = smtplib.SMTP(smtp_host)
			if smtpAuth.lower()=='y':
				server.login(smtpUser,smtpPass)
			server.sendmail(localemail, remoteemail, "Subject: WM_req-"+str(reqid)+"\r\nprot##http\r\n"+rawrequest+"\r\n.\r\n")
			server.quit()
			print "Email sent: ",reqid
		except Exception,a:
			print "Error sending e-mail"
			print "--- ErrMSG : ",a
			return

		while True:
			if reqid in mr.responses:
				result=mr.responses[reqid]
				break
			time.sleep(0.5)

		self.connection.send(result)

	do_HEAD = do_GET
	do_POST = do_GET
	do_PUT  = do_GET
	do_DELETE=do_GET

class ThreadingHTTPServer (SocketServer.ThreadingMixIn, BaseHTTPServer.HTTPServer): 
	pass

	
	
class proxy (threading.Thread):
	def __init__ (self,port):
		threading.Thread.__init__(self)
		self.exclude=""
		self.stop=False
		self.server_address = ('', port)
		self.httpd = ThreadingHTTPServer(self.server_address, ProxyHandler)


	def run(self):
		while not self.stop:
			self.httpd.handle_request()
		del self.httpd


class Proxynet:
	__PROXY_REQUESTS=[]
	__nreqs=0
	exclude=None
	def __init__(self,port=8008):
		self.port=port
		self.prox=None
		self.exclude=None

	def setPort(self,port):
		self.port=port

	def init (self,exclude=""):
		self.prox=proxy(self.port)
		Proxynet.exclude=exclude.lower()

		self.prox.start()

	def stop (self):
		if self.prox:
			self.prox.stop=True
			s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
			s.connect(("127.0.0.1", self.port))
			s.close()
			self.prox.join()	
			del self.prox
			self.prox=None

banner='''
*******************************************
* Http-SMTP Proxy by Carlos del ojo Elias *
* Internal Server                   *******
* email: cdelojo@edge-security.com  *
* www.edge-security.com             *
*************************************
'''

print banner

print "\r\nReading configuration file: hosproxy.cfg...\r\n"

config = ConfigParser.ConfigParser()
config.readfp(open('hosproxy.cfg'))
config=dict(config.items("CFG"))
		
smtp_host=config["local_smtp_server"]
client=config["mail_retrieve_protocol"]
imapop_host=config["mail_access_server"]
username=config["mas_user"]
passwd=config["mas_passwd"]
localemail=config["email"]
remoteemail=config["ext_email"]
smtpAuth=config["smtp-auth"]
smtpUser=config["smtp-user"]
smtpPass=config["smtp-pass"]

if not smtp_host or not client or not username or not localemail or not remoteemail:
	print "Please write your configuration in hosproxy.cfg  :D\r\n"
	sys.exit (-1)

if client.lower() not in ["pop","popssl","imap","imapssl"]:
	print "Bad configuration: mail_access_server"
	print
	sys.exit(-1)

if not passwd:
	print "Insert your password for your mail access server please."
	passwd=getpass.getpass()

if smtpAuth.lower()=="y" and not smtpPass:
	print "Insert your password for your SMTP server please."
	smtpPass=getpass.getpass()
	



print
print "OK !!! Now you can connect your web browser to localhost:8008 and enjoy! ;D "
print 
print "Listening..."

		
try:
	mr=mailretriever.mailretriever(imapop_host,client.lower(),username,passwd)
	mr.start()
	
	
	pr=Proxynet()
	pr.init("(jpg|gif|png|doc|pdf|zip)")

	while True:
		time.sleep(2)
except:
	print "\r\nExiting..."
	mr.stop()
	pr.stop()
	
	sys.exit(0)


