#Covered by GPL V2.0
# Coded By deepbit (Carlos del Ojo Elias)
# email deepbit@gmail.com


import imaplib,poplib,time,threading,sys
import TextParser, gzip, StringIO, string, base64

class mailretriever (threading.Thread):
	def __init__(self,host,protocol,user,password):
		''' protocols: pop,popssl,imap,imapssl '''
		threading.Thread.__init__(self)
		self.host=host
		self.protocol=protocol
		self.user=user
		self.password=password
		self.running=True
		self.popbegin=0

		self.responses={}

	def run(self):

		print "Connecting Mail Access Server (%s)..." % (self.protocol)
		
		try:
			if self.protocol in ['imap','imapssl']:
				if self.protocol=='imap':
					self.MC = imaplib.IMAP4(self.host)
				else:
					self.MC = imaplib.IMAP4_SSL(self.host)
	
				self.MC.login(self.user, self.password)
	
			if self.protocol in ['pop','popssl']:
				if self.protocol=='pop':
					MC=poplib.POP3(self.host)
					MC.user(self.user)
					MC.pass_(self.password)
					self.popbegin=MC.stat()[0]
					MC.quit()
					
				else:
					MC=poplib.POP3_SSL(self.host)
					MC.user(self.user)
					MC.pass_(self.password)
					self.popbegin=MC.stat()[0]
					MC.quit()
		except Exception,a:
			print "Error connecting mail access server!!"
			print "--- ErrMSG : ",a
			sys.exit(-1)

		print "Ok!"
			

		while self.running:
			try:
				self.readMail()
			except Exception,a:
				print "Error Retrieving: ",a
			time.sleep(3)

		if self.protocol in ['imap','imapssl']:
			self.MC.close()
			self.MC.logout()


	def store(self,result):
		self.responses[result[0]]=result[1]

	def stop(self):
		self.running=False
		
	
	def readMail(self):
		if self.protocol=='pop':
			a=mail_response()

		        MC=poplib.POP3(self.host)
		        MC.user(self.user)
		        MC.pass_(self.password)
		        numMessages = len(MC.list()[1])
		        for i in range(self.popbegin,numMessages):
		                ml=""
		                for j in MC.retr(i+1)[1]:
		                        ml+=j+"\r\n"
		                if a.parseMail(ml):
		                        MC.dele(i+1)
					self.store(a.getAll())
		
		        MC.quit()

			
		elif self.protocol=='popssl':
			a=mail_response()

		        MC=poplib.POP3_SSL(self.host)
		        MC.user(self.user)
		        MC.pass_(self.password)
		        numMessages = len(MC.list()[1])
		        for i in range(self.popbegin,numMessages):
		                ml=""
		                for j in MC.retr(i+1)[1]:
		                        ml+=j+"\r\n"
		                if a.parseMail(ml):
		                        MC.dele(i+1)
					self.store(a.getAll())
		
		        MC.quit()

		elif self.protocol=='imap':
			a=mail_response()
			
			self.MC.select()
			typ, data = self.MC.search(None, 'Subject','WM_req-')
			for num in data[0].split():
			    typ, data = self.MC.fetch(num, '(RFC822)')
			    if (a.parseMail(data[0][1])):
			        self.MC.store(num, '+FLAGS', '\\Deleted')
			        self.MC.expunge()
				self.store(a.getAll())
			

		elif self.protocol=='imapssl':
			a=mail_response()
			
			self.MC.select()
			typ, data = self.MC.search(None, 'Subject','WM_req-')
			for num in data[0].split():
			    typ, data = self.MC.fetch(num, '(RFC822)')
			    if (a.parseMail(data[0][1])):
			        self.MC.store(num, '+FLAGS', '\\Deleted')
			        self.MC.expunge()
				self.store(a.getAll())
			



class mail_response:
	def __init__(self):
		self.numReq=0

	def parseMail (self,mail):
		tp=TextParser.TextParser()
		tp.setSource("string",mail)
		if not tp.readUntil("^(Subject: )(WM_req-.*)$"):
			return False

		self.numReq=int(tp[1].split("-")[1])
		length=int(tp[1].split("-")[2])
		
		if not tp.readUntil("^$"):
			return False

		try:
			httpresp=""
			while tp.readLine():
				httpresp+=tp.lastFull_line
	
			httpresp=httpresp[:length].replace(" ","")
	
			compressedstream = StringIO.StringIO(base64.b64decode(httpresp))
			gzipper = gzip.GzipFile(fileobj=compressedstream)
			self.resp=gzipper.read()
			print "Fetched mail:",self.numReq 
			return True
		except:
			return False

			

	def getAll (self):
		return (self.numReq,self.resp)



